<?php

namespace BS\RealTimeChat\Entity;

use XF\Mvc\Entity\Entity;
use XF\Mvc\Entity\Structure;

/**
 * COLUMNS
 * @property int event_id
 * @property int event_time
 * @property string event_type
 * @property array event_data
 * @property array room_ids
 */

class LongPollingEvent extends Entity
{
    protected function setupApiResultData(\XF\Api\Result\EntityResult $result, $verbosity = self::VERBOSITY_NORMAL, array $options = [])
    {
        $result->event_time = $this->event_time;
        $result->event_type = $this->event_type;
        $result->event_data = $this->event_data;
    }

    public static function getStructure(Structure $structure)
    {
        $structure->table = 'xf_bs_chat_long_polling_event';
        $structure->shortName = 'BS\RealTimeChat:LongPollingEvent';
        $structure->primaryKey = 'event_id';
        $structure->columns = [
            'event_id' => ['type' => self::UINT, 'autoIncrement' => true],
            'event_time' => ['type' => self::UINT, 'default' => time()],
            'event_type' => ['type' => self::STR, 'required' => true],
            'event_data' => ['type' => self::JSON_ARRAY, 'default' => []],
            'room_ids' => ['type' => self::LIST_COMMA, 'default' => []]
        ];

        return $structure;
    }
}