<?php

namespace BS\RealTimeChat\LongPoll\Room;

use BS\RealTimeChat\LongPoll\RoomAdapterInterface;

abstract class AbstractRoomAdapter implements RoomAdapterInterface
{
    /** @var \XF\App */
    protected $app;

    protected $rooms = [];

    protected $visitorRooms = [];

    public function __construct(\XF\App $app)
    {
        $this->app = $app;
    }

    public function to($roomId) : RoomAdapterInterface
    {
        $this->rooms[$roomId] = $roomId;

        return $this;
    }

    public function in($roomId) : RoomAdapterInterface
    {
        return $this->to($roomId);
    }

    public function join($roomIds) : RoomAdapterInterface
    {
        foreach ((array)$roomIds as $roomId)
        {
            $this->visitorRooms[$roomId] = $roomId;
        }

        return $this;
    }
}