<?php

namespace BS\RealTimeChat\LongPoll\Room;

use BS\RealTimeChat\LongPoll\RoomAdapterInterface;
use XF\Mvc\Entity\ArrayCollection;

class Db extends AbstractRoomAdapter
{
    public function hasNewEvents($lastEventTime, array $eventTypes = []): ArrayCollection
    {
        /** @var \BS\RealTimeChat\Finder\LongPollingEvent $finder */
        $finder = $this->finder('BS\RealTimeChat:LongPollingEvent')
            ->order('event_time');

        $finder->hasOrEmptyRooms($this->visitorRooms)
            ->afterTime($lastEventTime);

        if (! empty($eventTypes))
        {
            $finder->inTypes($eventTypes);
        }

        return $finder->fetch();
    }

    public function emit(): RoomAdapterInterface
    {
        /** @var \BS\RealTimeChat\Entity\LongPollingEvent $event */
        $event = $this->em()->create('BS\RealTimeChat:LongPollingEvent');

        $args = func_get_args();

        $type = array_shift($args);

        if (count($args) == 1 && is_array($args))
        {
            $args = reset($args);
        }

        $event->room_ids = $this->rooms;
        $event->event_type = $type;
        $event->event_data = $args;
        $event->save();

        $this->rooms = [];

        return $this;
    }

    /**
     * @return \XF\Mvc\Entity\Manager
     */
    public function em()
    {
        return $this->app->em();
    }

    /**
     * @param $finder
     *
     * @return \XF\Mvc\Entity\Finder
     */
    public function finder($finder)
    {
        return $this->app->finder($finder);
    }
}