<?php

namespace BS\RealTimeChat\Repository;

use XF\Mvc\Entity\Finder;
use XF\Mvc\Entity\Repository;

class Command extends Repository
{
    public function findCommandsForList()
    {
        $finder = $this->finder('BS\RealTimeChat:Command');

        return $finder;
    }

    public function findActiveCommands()
    {
        $finder = $this->finder('BS\RealTimeChat:Command')
            ->where('active', true)
            ->where('AddOn.active', true);

        return $finder;
    }

    public function getCommandsCacheData()
    {
        $commands = $this->findActiveCommands()->fetch();

        $cache = [];

        foreach ($commands AS $commandId => $command)
        {
            $command = $command->toArray();
            unset($command['command_id'], $command['addon_id']);

            $cache[$commandId] = $command;
        }

        return $cache;
    }

    public function rebuildCommandsCache()
    {
        $cache = $this->getCommandsCacheData();
        \XF::registry()->set('bsRtcCommands', $cache);
        return $cache;
    }
}