<?php

namespace BS\RealTimeChat\Repository;

use XF\Mvc\Entity\Finder;
use XF\Mvc\Entity\Repository;

class Message extends Repository
{
    public function findMessages()
    {
        $limit = $this->options()->realTimeChatMessageLimit;

        $messageFinder = $this->finder('BS\RealTimeChat:Message')
            ->skipIgnored()
            ->skipPm()
            ->order('message_date', 'desc')
            ->with(['User', 'PmUser', 'ToUser'])
            ->limit($limit);

        return $messageFinder;
    }

    public function getMessagesForList($lastUpdate = 0)
    {
        $limit = $this->options()->realTimeChatMessageLimit;

        $messageFinder = $this->finder('BS\RealTimeChat:Message')
            ->skipIgnored()
            ->skipPm()
            ->order('message_date', 'desc')
            ->with(['User', 'PmUser', 'ToUser'])
            ->limit($limit);

        if ($lastUpdate)
        {
            $messageFinder->where('message_date', '>', $lastUpdate);
        }

        $messages = $messageFinder->fetch()->reverse();   

        return $messages;
    }
}