<?php

namespace BS\RealTimeChat\Search\Data;

use XF\Mvc\Entity\Entity;
use XF\Search\Data\AbstractData;
use XF\Search\IndexRecord;
use XF\Search\MetadataStructure;

class Message extends AbstractData
{
    public function getIndexData(Entity $message)
    {
        if ($message->pm_user_id)
        {
            return null;
        }

        return IndexRecord::create('chat_message', $message->message_id, [
            'title' => '',
            'message' => $message->message,
            'date' => $message->message_date,
            'user_id' => $message->user_id
        ]);
    }

    public function setupMetadataStructure(MetadataStructure $structure)
    {
    }

    public function getResultDate(Entity $message)
    {
        return $message->message_date;
    }

    public function getTemplateData(Entity $message, array $options = [])
    {
        return [
            'message' => $message,
            'options' => $options
        ];
    }

    public function canUseInlineModeration(Entity $message, &$error = null)
    {
        return false;
    }

    public function getSearchableContentTypes()
    {
        return ['chat_message'];
    }

    public function getSearchFormTab()
    {
        return null;
    }

    public function getSectionContext()
    {
        return null;
    }

    public function getSearchFormData()
    {
        return null;
    }
}