<?php

namespace BS\RealTimeChat\Widget;

use BS\RealTimeChat\Repository\Message;
use XF\Widget\AbstractWidget;

class Chat extends AbstractWidget
{
    public function render()
    {
        $visitor = \XF::visitor();

        if ($visitor->canViewChat())
        {
            $permissions = [
                'canDelete' => $visitor->hasChatPermission('canDelete'),
                'canEdit' => $visitor->hasChatPermission('canEdit'),
                'canEditAny' => $visitor->hasChatPermission('canEditAny'),
                'canDeleteAny' => $visitor->hasChatPermission('canDeleteAny'),
                'canReport' => $visitor->canReport()
            ];

        	$viewParams = [
        		'messages' => $this->getMessageRepo()->getMessagesForList(),

                'permissions' => $permissions
            ];

            return $this->renderer('real_time_chat', $viewParams);
        }
    }

    public function getOptionsTemplate()
    {
        return null;
    }

    /** @return Message */
    protected function getMessageRepo()
    {
        return $this->repository('BS\RealTimeChat:Message');
    }
}